/*
 * Hanashizume no Matsuri for X
 * Copyright (c) 2000 TF <tf@denpa.org>
 * All rights reserverd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: PanelP.h,v 1.14 2001/01/08 14:13:37 tf Exp $
 */
#ifndef _PanelP_h
#define _PanelP_h

#define INTERVAL 100

#include <X11/CompositeP.h>
#include "Panel.h"

#include "hana.h"

typedef struct {int foo;} PanelClassPart;

typedef struct _PanelClassRec {
        CoreClassPart      core_class;
        CompositeClassPart composite_class;
        PanelClassPart     panel_class;
} PanelClassRec;

extern PanelClassRec panelClassRec;

typedef struct {
  /* resource */
  Bool load_game;
  Bool redraw;
  XFontStruct *font;
  /* private */
  GC gc;
  /* position to draw character */
  int cur_x;
  int cur_y;
  /* internal state */
  int state;
  /* for text drawing */
  long black_pixel;
  long white_pixel;
  long gray_pixel;
  long yellow_pixel;
  /* for text drawing */
  int text_cache[1024];
  int text_cache_len;

  /* buffer shared with scenario engine */
  COMMAND command;
  XtIntervalId timewait_id;

  /* for image handling */
  Image *bgimage;
  Image *workimage;
  Image *white;
  Bool prevgray; /* if previous image effect was grayscale */

  Bool pending_page_end;
  int alternative[MAX_ALT][BUFLEN];
  int alt_x[MAX_ALT][2];
  int alt_y[MAX_ALT][2];
  int alt_cur_x[MAX_ALT];
  int alt_cur_y[MAX_ALT];
  int selection;

  Bool music_playing;
} PanelPart;

typedef struct _PanelRec {
  CorePart       core;
  CompositePart  composite;
  PanelPart      panel;
} PanelRec;

#endif /* _PanelP_h */
